<?php 
//block_gmoodle_xlink.php,v 1.0 16/11/2010
//www.badiu.net
// para versão 1.7 ou superior do Moodle

class block_gmoodle_xlink extends block_base {

    function init() {
        $this->title = get_string('gmoodle_xlink', 'block_gmoodle_xlink');
        $this->version = 2010101509;
    }

    function applicable_formats() {
        return array('all' => true);
    }

    function specialization() {
        $this->title = isset($this->config->title) ? format_string($this->config->title) : format_string(get_string('gmoodle_xlink', 'block_gmoodle_xlink'));
    }

    function instance_allow_multiple() {
        return true;
    }

    function get_content() {
        if ($this->content !== NULL) {
            return $this->content;
        }

        $filteropt = new stdClass;
        $filteropt->noclean = true;

        $this->content = new stdClass;
        $this->content->text = isset($this->config->text) ? format_text($this->config->text, FORMAT_HTML, $filteropt) : '';
        
        if (!empty($this->config->selectinstructor)) {
			$user = get_complete_user_data('id', $this->config->selectinstructor);
        }
        global $COURSE,$USER;
        str_replace("merda","CENSURADO",$string);
        //substituir id do curso
         $this->content->text= str_replace("@ID_CURSO",$COURSE->id,$this->content->text);
        //substituir id do usuário
        $this->content->text= str_replace("@ID_USR",$USER->id,$this->content->text);
        $this->content->footer = '';

        unset($filteropt); 

        return $this->content;
    }

  
    function get_backup_encoded_config() {
       
        if (empty($this->config)) {
            return parent::get_backup_encoded_config();
        }
        $data = clone($this->config);
        $data->text = backup_encode_absolute_links($data->text);
        return base64_encode(serialize($data));
    }

   
    function decode_content_links_caller($restore) {
        global $CFG;

        if ($restored_blocks = get_records_select("backup_ids","table_name = 'block_instance' AND backup_code = $restore->backup_unique_code AND new_id > 0", "", "new_id")) {
            $restored_blocks = implode(',', array_keys($restored_blocks));
            $sql = "SELECT bi.*
                      FROM {$CFG->prefix}block_instance bi
                           JOIN {$CFG->prefix}block b ON b.id = bi.blockid
                     WHERE b.name = 'gmoodle_xlink' AND bi.id IN ($restored_blocks)"; 

            if ($instances = get_records_sql($sql)) {
                foreach ($instances as $instance) {
                    $blockobject = block_instance('gmoodle_xlink', $instance);
                    $blockobject->config->text = restore_decode_absolute_links($blockobject->config->text);
                    $blockobject->config->text = restore_decode_content_links_worker($blockobject->config->text, $restore);
                    $blockobject->instance_config_commit($blockobject->pinned);
                }
            }
        }

        return true;
    }
}
?>
